"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _memoizerific = _interopRequireDefault(require("memoizerific"));

var _api = require("@storybook/api");

var _components = require("@storybook/components");

var _constants = require("../constants");

var _PaddingIcon = _interopRequireDefault(require("../components/PaddingIcon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var defaultPadding = '';
var createPaddingSelectorItem = (0, _memoizerific["default"])(1000)(function (id, name, value, hasValue, change) {
  return {
    id: id || name,
    title: name,
    onClick: function onClick() {
      change({
        selected: value,
        name: name
      });
    },
    value: value,
    right: hasValue ? value : undefined
  };
});

var getSelectedPadding = function getSelectedPadding(list, currentSelectedValue) {
  if (!list.length) {
    return defaultPadding;
  }

  if (currentSelectedValue === defaultPadding) {
    return currentSelectedValue;
  }

  if (list.find(function (i) {
    return i.value === currentSelectedValue;
  })) {
    return currentSelectedValue;
  }

  var defaultInput = list.find(function (i) {
    return i["default"];
  });

  if (defaultInput) {
    return defaultInput.value;
  }

  return defaultPadding;
};

var getDisplayedItems = (0, _memoizerific["default"])(10)(function (list, selected, change) {
  var availablePaddingSelectorItems = [];

  if (selected !== defaultPadding) {
    availablePaddingSelectorItems.push(createPaddingSelectorItem('reset', 'Clear paddings', defaultPadding, null, change));
  }

  if (list.length) {
    availablePaddingSelectorItems.push.apply(availablePaddingSelectorItems, _toConsumableArray(list.map(function (_ref) {
      var name = _ref.name,
          value = _ref.value;
      return createPaddingSelectorItem(null, name, value, true, change);
    })));
  }

  return availablePaddingSelectorItems;
});

var PaddingSelector = function PaddingSelector(_ref2) {
  var api = _ref2.api;
  var items = (0, _api.useParameter)(_constants.PARAM_KEY, []);
  var selectedPadding = getSelectedPadding(items, api.getAddonState(_constants.PARAM_KEY));
  return items.length ? _react["default"].createElement(_components.WithTooltip, {
    placement: "top",
    trigger: "click",
    tooltip: function tooltip(_ref3) {
      var onHide = _ref3.onHide;
      return _react["default"].createElement(_components.TooltipLinkList, {
        links: getDisplayedItems(items, selectedPadding, function (_ref4) {
          var selected = _ref4.selected;
          api.setAddonState(_constants.PARAM_KEY, selected);
          api.emit(_constants.EVENTS.UPDATE, selected);
          onHide();
        })
      });
    },
    closeOnClick: true
  }, _react["default"].createElement(_components.IconButton, {
    key: "padding",
    active: selectedPadding !== defaultPadding,
    title: "Change the paddings of the preview"
  }, _react["default"].createElement(_PaddingIcon["default"], null))) : null;
};

var _default = PaddingSelector;
exports["default"] = _default;