"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withPaddings = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactEasyState = require("react-easy-state");

var _addons = require("@storybook/addons");

var _theming = require("@storybook/theming");

var _constants = require("./constants");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var state = (0, _reactEasyState.store)({
  initialized: false,
  padding: ''
});

var setPadding = function setPadding() {
  var padding = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  if (!state.initialized) state.initialized = true;
  state.padding = padding;
};

var bodyClass = 'sb-show-main';
var Wrapper = (0, _reactEasyState.view)(function (_ref) {
  var children = _ref.children,
      _ref$settings$paramet = _ref.settings.parameters,
      parameters = _ref$settings$paramet === void 0 ? {} : _ref$settings$paramet;
  var _parameters$disabled = parameters.disabled,
      disabled = _parameters$disabled === void 0 ? false : _parameters$disabled;
  (0, _react.useEffect)(function () {
    // PaddingSelector emits the default selection before this wrapper
    // can subscribe to the channel, so manually set initial padding on
    // first render. This workaround should be removed once we can share
    // state between manager and preview.
    // See https://github.com/storybookjs/storybook/pull/9079
    if (!state.initialized) {
      var _parameters$find;

      var defaultValue = Array.isArray(parameters) ? (_parameters$find = parameters.find(function (param) {
        return param["default"];
      })) === null || _parameters$find === void 0 ? void 0 : _parameters$find.value : undefined;
      setPadding(defaultValue);
    }
  }, [parameters]);
  (0, _react.useEffect)(function () {
    var channel = _addons.addons.getChannel();

    channel.on(_constants.EVENTS.UPDATE, setPadding);
    return function () {
      return channel.off(_constants.EVENTS.UPDATE, setPadding);
    };
  }, []);
  return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_theming.Global, {
    styles: _defineProperty({}, ".".concat(bodyClass), {
      padding: !disabled && state.padding,
      transition: 'padding .3s'
    })
  }), children);
});
var withPaddings = (0, _addons.makeDecorator)({
  name: 'withPaddings',
  parameterName: _constants.PARAM_KEY,
  allowDeprecatedUsage: true,
  skipIfNoParametersOrOptions: true,
  wrapper: function wrapper(getStory, context, settings) {
    return _react["default"].createElement(Wrapper, {
      settings: settings
    }, getStory(context));
  }
});
exports.withPaddings = withPaddings;